<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AnularDocumentoDeCompraSimples StructType
 * @subpackage Structs
 */
class AnularDocumentoDeCompraSimples extends AbstractStructBase
{
    /**
     * The documentoCompra
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabecComprasERP
     */
    public $documentoCompra;
    /**
     * The motivoAnulacao
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $motivoAnulacao;
    /**
     * Constructor method for AnularDocumentoDeCompraSimples
     * @uses AnularDocumentoDeCompraSimples::setDocumentoCompra()
     * @uses AnularDocumentoDeCompraSimples::setMotivoAnulacao()
     * @param \StructType\CabecComprasERP $documentoCompra
     * @param string $motivoAnulacao
     */
    public function __construct(\StructType\CabecComprasERP $documentoCompra = null, $motivoAnulacao = null)
    {
        $this
            ->setDocumentoCompra($documentoCompra)
            ->setMotivoAnulacao($motivoAnulacao);
    }
    /**
     * Get documentoCompra value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabecComprasERP|null
     */
    public function getDocumentoCompra()
    {
        return isset($this->documentoCompra) ? $this->documentoCompra : null;
    }
    /**
     * Set documentoCompra value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CabecComprasERP $documentoCompra
     * @return \StructType\AnularDocumentoDeCompraSimples
     */
    public function setDocumentoCompra(\StructType\CabecComprasERP $documentoCompra = null)
    {
        if (is_null($documentoCompra) || (is_array($documentoCompra) && empty($documentoCompra))) {
            unset($this->documentoCompra);
        } else {
            $this->documentoCompra = $documentoCompra;
        }
        return $this;
    }
    /**
     * Get motivoAnulacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMotivoAnulacao()
    {
        return isset($this->motivoAnulacao) ? $this->motivoAnulacao : null;
    }
    /**
     * Set motivoAnulacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $motivoAnulacao
     * @return \StructType\AnularDocumentoDeCompraSimples
     */
    public function setMotivoAnulacao($motivoAnulacao = null)
    {
        // validation for constraint: string
        if (!is_null($motivoAnulacao) && !is_string($motivoAnulacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($motivoAnulacao)), __LINE__);
        }
        if (is_null($motivoAnulacao) || (is_array($motivoAnulacao) && empty($motivoAnulacao))) {
            unset($this->motivoAnulacao);
        } else {
            $this->motivoAnulacao = $motivoAnulacao;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AnularDocumentoDeCompraSimples
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
